import scala.language.implicitConversions

object MyRed {
	implicit def list2MyList[T](l:List[T]):MyRed[T] = {
		MyRed(l)
	}
}

case class MyRed[T](l:List[T]) {
	def myReduce(f:(T,T)=>T):Option[T] = {
		def aux(m:List[T]):T = {
			require(!m.isEmpty)
			if (m.tail.isEmpty) m.head
			else f(m.head,aux(m.tail))
		}
		if (l.isEmpty) None else Some(aux(l))
	}
}
